<?php

// Parameter
// GET: path, bildnr
include "config.php";
$smarty->assign('title', "Bild");

if (! $filmdir = opendir ( $_GET ['path'] )) {
	die ( "Konnte Filmverzeichnis nicht ffnen." );
}
closedir ( $filmdir );

// trenne Ordnername fr SQL Abfragen
$filmnr_kurz = intval ( substr ( basename ( $_GET ['path'] ), 0, 3 ) );
$filmnr_lang = intval ( substr ( basename ( $_GET ['path'] ), 4, 4 ) );

// Bild, das vom Benutzer ausgewhlt wurde, enthlt den Beginn einer Konkursrubrik
$bildnr = $_GET ['bildnr'];

// Zurck ohne zu speichern
if (isset ( $_POST ['discard_and_return'] )) {
	header ( "Location: selektion.php?path=" . rawurlencode ( $_GET ['path'] ) . "#image_" . $bildnr );
	exit ();
}

// Ermittle die Ausgabe, in der sich die Konkurse befinden
// Jede Ausgabe kann mehrfach vorkommen, wenn die Konkursmitteilungen verstreut im Film liegen, jedes Bild
// hat aber eine eindeutige ID.
$sql = "SELECT kmit.id,kmit.ausgabe,kmit.done,kmit.bemerk,kmit.jahr,UNIX_TIMESTAMP(kmit.gesperrt) AS gesperrt,last 
FROM filme 
JOIN kmit ON filme.id = kmit.fid 
WHERE filme.filmnr_kurz=$filmnr_kurz AND filme.filmnr_lang=$filmnr_lang AND kmit.bildnr=$bildnr";
$res = $db->query ( $sql );
if ($res->num_rows == 0) {
	// das darf nicht passieren
	die ( "Kann fr das Bild mit der Nummer $bildnr im Film $filmnr_kurz-$filmnr_lang keine Konkursbekanntmachungen in der Datenbank finden. Bitte prfen, ob das Bild als Bild mit Konkursen markiert wurde." );
} else {
	$obj = $res->fetch_object ();
	$ausgabe = $obj->ausgabe; // kann leer sein (NULL)
	$ausgabe_id = $obj->id; // kann nicht leer sein
	$done = $obj->done; // boolisch
	$bemerk = $obj->bemerk;
	$jahr = $obj->jahr;
	$last = $obj->last;
	
	// ggf. Bild entsperren nach mehr als 1 Tag
	if ($obj->gesperrt < (time () - 24 * 60 * 60)) {
		$sql = "UPDATE kmit SET gesperrt = NULL WHERE id = $ausgabe_id";
		$db->query ( $sql );
		$obj->gesperrt = null;
	}
	$gesperrt = $obj->gesperrt;
}

// +++ save and return / save_and_link / toggle_done +++
if (isset ( $_POST ['save_and_return'] ) || isset ( $_POST ['save_and_link'] ) || isset ( $_POST ['toggle_done'] )) {
	// +++ update bemerkungen, wenn gendert +++
	if (isset ( $_POST ['bemerk'] )) {
		if ($bemerk != $_POST ['bemerk']) {
			// zum Update
			$bemerk_update = $db->real_escape_string ( htmlspecialchars_decode ( $_POST ['bemerk'] ) );
			$sql = "UPDATE kmit SET bemerk='$bemerk_update', last='$kuerzelsql' WHERE kmit.id = $ausgabe_id";
			$res = $db->query ( $sql );
			// zur Anzeige
			$bemerk = $_POST ['bemerk'];
		}
	}
	// fhre spezifische Aktion durch
	if (isset ( $_POST ['save_and_return'] )) {
		// ggf. entsperren
		if ($gesperrt != null) {
			$sql = "UPDATE kmit SET gesperrt = NULL, last='$kuerzelsql' WHERE id = $ausgabe_id";
			$db->query ( $sql );
		}
		header ( "Location: selektion.php?path=" . rawurlencode ( $_GET ['path'] ) . "#image_" . $bildnr );
		exit ();
	} elseif (isset ( $_POST ['save_and_link'] )) {
		header ( "Location: " . $_POST ['save_and_link'] );
		exit ();
	} elseif (isset ( $_POST ['toggle_done'] )) {
		$done = $done ? 0 : 1; // flip bit
		$sql = "UPDATE kmit SET done=$done, last='$kuerzelsql' WHERE kmit.id = $ausgabe_id";
		$res = $db->query ( $sql );
	}
}

// fhre ggf. Sperrung durch
$jetzt_gesperrt = false;
if (isset ( $_GET ['sperren'] )) {
	// Bild noch nicht gesperrt
	if ($gesperrt == null) {
		$sql = "UPDATE kmit SET gesperrt=NOW(), last='$kuerzelsql' WHERE kmit.id = $ausgabe_id";
		$res = $db->query ( $sql );
		
		$jetzt_gesperrt = true;
		
		$sql = "SELECT gesperrt FROM kmit WHERE kmit.id = $ausgabe_id";
		$res = $db->query ( $sql );
		$gesperrt = $res->fetch_object ()->gesperrt;
	}
}

// Hole Sammlungen zur Linkgenerierung
$sammlungen = getSammlungen ();

// Lade die aus dieser Ausgabe bereits erfassten Konkurserffnungen
$sql = "SELECT E.`id`, E.`pid`, IF(EC.pid IS NULL,FALSE,TRUE) AS isparent,
E.`s_name`, E.`s_beruf`, E.`v_name`, E.`v_beruf`, E.`eroef_dat`, E.`bek_dat`, E.`s_ort`, E.`v_ort`, E.`t_dat`, E.`anz_dat`, 
E.`anm_dat`, E.`gvers_dat`, E.`pruef_dat`, E.`gericht`, E.`bemerk`, E.`last`, B.`id` AS bid, B.`aid` AS baid, FB.`filmnr_lang` AS bfilmnr_lang
FROM k_eroef AS E JOIN kmit AS K ON E.aid = K.id 
LEFT JOIN (k_beend AS B JOIN kmit AS KB ON B.aid = KB.id JOIN filme AS FB ON KB.fid = FB.id) 
ON B.`kid` = E.`id` 
LEFT JOIN k_eroef AS EC
ON E.id = EC.pid
WHERE K.id = $ausgabe_id 
GROUP BY E.id
ORDER BY E.gericht, E.bek_dat, COALESCE(E.pid,E.id), E.pid IS NULL DESC, E.pid
";
$res = $db->query ( $sql );
$smarty->assign ( 'num_eroef', $res->num_rows );
$k_eroef = array ();
while ( $assoc = $res->fetch_assoc () ) {
	// fge zu jeder Ergebniszeile Felder fr die Bildpfade fr die Beendigung hinzu, wenn eine verknpft ist
	$assoc ['bfilm_path'] = null;
	if (! is_null ( $assoc ['bfilmnr_lang'] )) {
		$assoc ['bfilm_path'] = getFilmPath ( $assoc ['bfilmnr_lang'], $sammlungen ) ? getFilmPath ( $assoc ['bfilmnr_lang'], $sammlungen ) : null;
	}
	// Dublettensuche anhand von Name, Erffnungsdatum und Bekanntmachungsdatum
	$eroef_id = $assoc ['id'];
	$s_name = $db->real_escape_string ( $assoc ['s_name'] );
	$eroef_dat = $assoc ['eroef_dat'];
	$bek_dat = $assoc ['bek_dat'];
	if (!is_null($assoc['pid'])) {
		$eroef_pid_bedingung = "AND E.id != $assoc[pid] AND E.pid != $assoc[pid]";
	} else {
		$eroef_pid_bedingung = "";
	}
	$sql = "SELECT E.id, K.bildnr, K.jahr, F.filmnr_kurz, F.filmnr_lang 
		FROM k_eroef AS E 
		JOIN kmit AS K ON E.aid = K.id 
		JOIN filme AS F ON K.fid = F.id 
		WHERE E.s_name = '$s_name' AND E.eroef_dat = '$eroef_dat' AND E.bek_dat = '$bek_dat' 
		AND E.id != $eroef_id AND E.pid != $eroef_id $eroef_pid_bedingung";
	$res_dub = $db->query ( $sql );
	$assoc ['dub_num'] = $res_dub->num_rows;
	while ( $assoc_dub = $res_dub->fetch_assoc () ) {
		$assoc_dub ['film_path'] = null;
		if (! is_null ( $assoc_dub ['filmnr_lang'] )) {
			$assoc_dub ['film_path'] = getFilmPath ( $assoc_dub ['filmnr_lang'], $sammlungen ) ? getFilmPath ( $assoc_dub ['filmnr_lang'], $sammlungen ) : null;
		}
		$assoc ['dubs'] [] = $assoc_dub;
	}
	$k_eroef [] = $assoc;
}
$smarty->assign ( 'k_eroef', $k_eroef );

// Lade die Konkursbeendigungen aus dieser Ausgabe und verknpfe sie mit vorhandenen Erffnungen
$sql = "SELECT B.`id`, B.`pid`, B.`kid`, IF(BC.pid IS NULL,FALSE,TRUE) AS isparent,
E.`s_name` AS es_name, E.`s_beruf` AS es_beruf, E.`s_ort` AS es_ort, E.`t_dat` AS et_dat, E.`gericht` AS egericht, E.bemerk as ebemerk,
KF.`filmnr_lang` AS efilmnr_lang, E.`aid` AS eaid,
B.`s_name` AS bs_name, B.`s_beruf` AS bs_beruf, B.`s_ort` AS bs_ort, B.`gericht` AS bgericht, B.`typ`, B.`aufh_dat`, B.`bek_dat`, 
B.`t_dat` AS bt_dat, B.`bemerk` AS bbemerk, B.`last` AS blast
FROM k_beend AS B 
JOIN kmit AS KB ON B.aid = KB.id 
LEFT JOIN ( 
	k_eroef AS E
	JOIN kmit AS KE ON E.aid = KE.id
	JOIN filme AS KF ON KE.fid = KF.id
)
ON B.kid = E.id
LEFT JOIN k_beend AS BC
ON B.id = BC.pid
WHERE KB.id = $ausgabe_id
GROUP BY B.id
ORDER BY COALESCE(bgericht, egericht), bek_dat, COALESCE(B.pid,B.id), B.pid IS NULL DESC, B.pid";
$res = $db->query ( $sql );
$smarty->assign ( 'num_beend', $res->num_rows );
$k_beend = array ();
while ( $assoc = $res->fetch_assoc () ) {
	// fge zu jeder Ergebniszeile Felder fr die Bildpfade fr die Erffnung hinzu, wenn eine verknpft ist
	$assoc ['efilm_path'] = null;
	if (! is_null ( $assoc ['efilmnr_lang'] )) {
		$assoc ['efilm_path'] = getFilmPath ( $assoc ['efilmnr_lang'], $sammlungen ) ? getFilmPath ( $assoc ['efilmnr_lang'], $sammlungen ) : null;
	}
	// Dublettensuche anhand von Name und Bekanntmachungsdatum
	$beend_id = $assoc ['id'];
	$bs_name = $db->real_escape_string ( $assoc ['bs_name'] );
	$es_name = $db->real_escape_string ( $assoc ['es_name'] );
	$bek_dat = $assoc ['bek_dat'];
	if (!is_null($assoc['pid'])) {
		$beend_pid_bedingung = "AND B.id != $assoc[pid] AND B.pid != $assoc[pid]";
	} else {
		$beend_pid_bedingung = "";
	}
	$sql = "SELECT B.id, K.bildnr, K.jahr, F.filmnr_kurz, F.filmnr_lang
		FROM k_beend AS B
		JOIN kmit AS K ON B.aid = K.id
		JOIN filme AS F ON K.fid = F.id
		LEFT JOIN k_eroef AS E ON B.kid = E.id
		WHERE (B.s_name = '$bs_name' OR B.s_name = '$es_name' OR E.s_name = '$bs_name' OR E.s_name = '$es_name')
		AND (B.bek_dat = '$bek_dat' AND B.id != $beend_id AND B.pid != $beend_id $beend_pid_bedingung)";
	$res_dub = $db->query ( $sql );
	$assoc ['dub_num'] = $res_dub->num_rows;
	while ( $assoc_dub = $res_dub->fetch_assoc () ) {
		$assoc_dub ['film_path'] = null;
		if (! is_null ( $assoc_dub ['filmnr_lang'] )) {
			$assoc_dub ['film_path'] = getFilmPath ( $assoc_dub ['filmnr_lang'], $sammlungen ) ? getFilmPath ( $assoc_dub ['filmnr_lang'], $sammlungen ) : null;
		}
		$assoc ['dubs'] [] = $assoc_dub;
	}
	$k_beend [] = $assoc;
}
$smarty->assign ( 'k_beend', $k_beend );

$smarty->assign ( 'film_path', $_GET ['path'] );
$smarty->assign ( 'filmnr_kurz', $filmnr_kurz );
$smarty->assign ( 'filmnr_lang', $filmnr_lang );
$smarty->assign ( 'bildnr', $bildnr );
$smarty->assign ( 'jahr', $jahr );
$smarty->assign ( 'ausgabe', $ausgabe );
$smarty->assign ( 'ausgabe_id', $ausgabe_id );
$smarty->assign ( 'done', $done );
$smarty->assign ( 'bemerk', $bemerk );
$smarty->assign ( 'gesperrt', $gesperrt );
$smarty->assign ( 'last', $last);
$smarty->assign ( 'jetzt_gesperrt', $jetzt_gesperrt );

$smarty->display ( 'auswertung.tpl' );

