<?php

// falls noch nicht inkludiert
require_once ("config.php");

// vielleicht gibt es noch einen eleganteren weg, das smarty plugin im code hier aufzurufen...
require_once ("plugins/modifier.mysqlDateToGerman.php");

// Hole Informationen ber die Filmsammlungen im Datenverzeichnis. Die Daten
// werden ausschlielich aus den Ordnernamen generiert.
function getSammlungen() {
	global $datadir_arr; // die Konfigurationsvariable in der Funktion bekannt machen
	
	$liste = array ();
	
	foreach ($datadir_arr as $datadir) {
		if (! $data_res = opendir ( $datadir )) {
			die ( "Konnte Datenverzeichnis \"$datadir\" nicht ffnen." );
		}
		while ( false !== ($sammlung_filename = readdir ( $data_res )) ) {
			if (! is_dir ( $datadir . $sammlung_filename ))
				continue;
			$sammlung_elements = explode ( " ", $sammlung_filename );
			if (count ( $sammlung_elements ) == 5) {
				// Informationen ber die Sammlung einholen
				$startdate = new DateTime ( $sammlung_elements [0] );
				$sammlung ["startdate"] = $startdate->format ( "d.m.Y" ) . "\n";
				$sammlung ["startyear"] = $startdate->format ( "Y" );
				$enddate = new DateTime ( $sammlung_elements [2] );
				$sammlung ["enddate"] = $enddate->format ( "d.m.Y" ) . "\n";
				$sammlung ["endyear"] = $enddate->format ( "Y" );
				$sammlung ["startfilm"] = strtok ( $sammlung_elements [4], "-" );
				$sammlung ["endfilm"] = strtok ( "-" );
				$sammlung ["anzahl"] = $sammlung ["endfilm"] - $sammlung ["startfilm"] + 1;
				$sammlung ["path"] = $datadir . $sammlung_filename; // absoluten Pfad merken
				$sammlung ["dirname"] = $sammlung_filename; // fr die Sortierung merken
				
				// Sammlung ffnen
				if (! $sammlung_res = opendir($datadir . $sammlung_filename)) {
					die ( "Konnte Sammlung " . $datadir . $sammlung_filename . " nicht ffnen." );
				}
				$filmliste = array();
				while (false !== ($film_filename = readdir ( $sammlung_res ))) {
					if (! is_dir ( $datadir . $sammlung_filename . "/" . $film_filename ))
						continue;
					$film_elements = explode ( "-", $film_filename );
					if (count($film_elements) == 2) {
						// Informationen ber den Film einholen
						$film["filmnr_kurz"] = $film_elements[0];
						$film["filmnr_lang"] = $film_elements[1];
						$filmliste[] = $film;
					}
				}
				closedir($sammlung_res);
				$sammlung['filme'] = $filmliste;
				
				$liste [] = $sammlung;
			}
		}
		closedir ( $data_res );
	}
	if (count ( $liste ) == 0) {
		die ( "Keine Filmsammlungen gefunden in den Datenverzeichnissen." );
	}
	// sortiere die Liste der Filmsammlungen nach dem Verzeichnisnamen
	usort($liste, function($a, $b) {
		$a_dirname = $a['dirname'];
		$b_dirname = $b['dirname'];
		$sort_array = array($a_dirname, $b_dirname);
		sort($sort_array);
		if ($sort_array[0] == $sort_array[1])
			return 0; 
		elseif ($sort_array[0] == $a_dirname)
			return -1;
		elseif ($sort_array[0] == $b_dirname)
			return 1;
	});
	return $liste;
}

// die Funktion gibt den absoluten Pfad des ersten gefundenen passenden Filmverzeichnisses zurck
function getFilmPath($filmnr_lang, $sammlungen) {
	// gehe die Sammlungen durch
	foreach ($sammlungen as $sammlung) {
		// falls die Sammlung Filme hat, gehe die Filme durch
		if ($sammlung['filme']) {
			foreach ($sammlung['filme'] as $film) {
				if ($film['filmnr_lang'] == $filmnr_lang) {
					// gefunden!
					return $sammlung['path'] . '/' . $film['filmnr_kurz'] . "-" . $film['filmnr_lang'];
				}
			}
		}
	}
	return false; // nichts gefunden
}

?>