<?php
require_once ("config.php");
$smarty->assign ( 'title', "VIDs" );

// initialisieren, damit die bergabe als Templatevariable keine Warnung erzeugt

// Speichern
if (isset ( $_POST ['save_and_reload'] ) && isset ( $_POST ['data'] )) {
	$data = $_POST ['data'];
	$sql = "";
	$aff = 0; // auf 0 setzen, damit die Variable numerisch wird
	$neu = array ();
	foreach ( $data as $key => $row ) {
		$vid = $db->real_escape_string ( $row ['vid'] );
		$vid_alt = $db->real_escape_string ( $row ['vid_alt'] );
		$gericht_cn = $db->real_escape_string ( $row ['gericht_cn'] );
		$v_name = $db->real_escape_string ( $row ['v_name'] );
		$v_beruf = $db->real_escape_string ( $row ['v_beruf'] );
		
		if (isset ( $row ['bemerk'] )) {
			$bemerk = $db->real_escape_string ( $row ['bemerk'] );
		}
		
		// numerische und leere VIDs aktualisieren
		// Achtung: Es findet kein DELETE im table verw statt, wenn eine VID in k_eroef nicht mehr auftaucht,
		// daher ist eine Bereinigung verwaister Eintrge in verw regelmig ntig.
		if ((ctype_digit ( $vid ) && intval ( $vid ) == $vid) || $vid == "") {
			$vid = $vid == "" ? "NULL" : $vid;
			$vid_alt = $vid_alt == "" ? "NULL" : $vid_alt;
			
			if ($vid != "NULL" && isset ( $row ['bemerk'] )) {
				$sql = "INSERT INTO verw
				SET id=$vid, bemerk='$bemerk'
				ON DUPLICATE KEY UPDATE bemerk='$bemerk'";
				$db->query ( $sql );
				$aff += $db->affected_rows;
			}
			
			$sql = "UPDATE k_eroef_cn E
				SET E.vid = $vid
				WHERE E.gericht_cn = '$gericht_cn'
				AND E.v_name = '$v_name'
				AND E.v_beruf = '$v_beruf'
				AND E.vid <=> $vid_alt;";
			$db->query ( $sql );
			$aff += $db->affected_rows;
		} elseif (ctype_alpha ( $vid )) { // alphabetische VID Platzhalter verarbeiten
			$neu [$vid] [] = $key;
		}
	}
	// neue alphabetische VIDs gefunden
	if (count ( $neu ) > 0) {
		$sql = "SELECT MAX(vid) FROM k_eroef_cn";
		$neue_vid = $db->query ( $sql )->fetch_row () [0] + 1;
		foreach ( $neu as $gruppe ) {
			foreach ( $gruppe as $key ) {
				$vid_alt = $db->real_escape_string ( $data [$key] ['vid_alt'] );
				$gericht_cn = $db->real_escape_string ( $data [$key] ['gericht_cn'] );
				$v_name = $db->real_escape_string ( $data [$key] ['v_name'] );
				$v_beruf = $db->real_escape_string ( $data [$key] ['v_beruf'] );
				$bemerk = $db->real_escape_string ( $data [$key] ['bemerk'] );
				
				$vid_alt = $vid_alt == "" ? "NULL" : $vid_alt;
				
				$sql = "INSERT INTO verw
				SET id=$neue_vid, bemerk='$bemerk'
				ON DUPLICATE KEY UPDATE bemerk='$bemerk'";
				$db->query ( $sql );
				$aff += $db->affected_rows;
				
				$sql = "UPDATE k_eroef_cn E
					SET E.vid=$neue_vid
					WHERE E.gericht_cn = '$gericht_cn'
					AND E.v_name = '$v_name'
					AND E.v_beruf = '$v_beruf'
					AND E.vid <=> $vid_alt;";
				$db->query ( $sql );
				//echo $sql . "<br />";
				$aff += $db->affected_rows;
			}
			$neue_vid ++;
		}
	}
}
if (isset ( $_POST ['konsolidieren'] )) {
	$aff = 0;
	$sql = "UPDATE k_eroef_cn AS k1 
		JOIN k_eroef_cn AS k2 ON ((k1.v_name = k2.v_name) AND (k1.gericht_cn = k2.gericht_cn) AND (k1.v_beruf = k2.v_beruf)) 
		SET k2.vid = k1.vid 
		WHERE k1.vid != 0 AND k2.vid IS NULL";
	$db->query ( $sql );
	$aff += $db->affected_rows;
}
// Anzeigen
$opt = array (
		'lw_order' => 'Sortierung nach letztem Wort > 3 Zeichen',
		'ab_del' => '+ Anfangsbuchstaben des letzten Worts > 3 Zeichen entfernen',
		'konv' => 'Standardkonvertierungen',
		'regio' => 'Regionalgruppierung',
		'vid_order' => 'VID Sortierung' 
);
$opt_sel = isset ( $_POST ['options'] ) ? $_POST ['options'] : array ();

// Gerichte einschrnken
$sql_where = "";
$gericht = "";
if (isset ( $_POST ['gericht'] ) && $_POST ['gericht'] != "") {
	$gericht = $db->real_escape_string ( $_POST ['gericht'] );
	$sql_where = "gericht_cn = '$gericht'";
}
$regio_gericht = "";
if (isset ( $_POST ['regio_gericht'] ) && $_POST ['regio_gericht'] != "") {
	$regio_gericht = $db->real_escape_string ( $_POST ['regio_gericht'] );
	if ($sql_where != "") {
		$sql_where .= " OR ";
	}
	$sql_where .= "regiogericht_cn = '$regio_gericht'";
}
if ($sql_where != "") {
	$sql_where = " AND (" . $sql_where . ")";
}
// modifizierte Spalte generieren und nach ihr sortieren
// Sortierung nach letztem Wort > n Zeichen
if (isset ( $_POST ['del_words'] )) {
	$del_words = htmlspecialchars_decode ( $_POST ['del_words'] );
} else {
	$del_words = "";
}
$del_arr = explode ( ' ', $del_words );
$base_field = "v_name";
// verschachtelte REPLACE fr jedes zu entfernende Wort
foreach ( $del_arr as $i ) {
	if ($i != "")
		$base_field = "REPLACE($base_field, '$i', '')";
}
// Konvertierungen
if (isset ( $opt_sel ) && array_search ( 'konv', $opt_sel ) !== false) {
	$base_field = "REPLACE($base_field, '', 'ae')";
	$base_field = "REPLACE($base_field, '', 'oe')";
	$base_field = "REPLACE($base_field, '', 'ue')";
	$base_field = "REPLACE($base_field, '', 'ss')";
}
if (isset ( $opt_sel ) && ((array_search ( 'lw_order', $opt_sel ) !== false) || $del_words != "")) { // aktiviere vmod-Spalte
	if (array_search ( 'lw_order', $opt_sel ) !== false && array_search ( 'ab_del', $opt_sel ) === false) {
		$sql_vmod_field = ", IF(LENGTH(SUBSTRING_INDEX(TRIM($base_field),' ',-1)) > 3, SUBSTRING_INDEX(TRIM($base_field),' ',-1), SUBSTRING_INDEX(TRIM($base_field),' ',-2)) AS vmod";
	} elseif (array_search ( 'lw_order', $opt_sel ) !== false && array_search ( 'ab_del', $opt_sel ) !== false) {
		$sql_vmod_field = ", RIGHT(IF(LENGTH(SUBSTRING_INDEX(TRIM($base_field),' ',-1)) > 3, SUBSTRING_INDEX(TRIM($base_field),' ',-1), SUBSTRING_INDEX(TRIM($base_field),' ',-2)),
							LENGTH(IF(LENGTH(SUBSTRING_INDEX(TRIM($base_field),' ',-1)) > 3, SUBSTRING_INDEX(TRIM($base_field),' ',-1), SUBSTRING_INDEX(TRIM($base_field),' ',-2)))-1) AS vmod";
	} else {
		$sql_vmod_field = ", TRIM($base_field) AS vmod";
	}
	$sql_name_order = ", vmod";
} else {
	$sql_vmod_field = "";
	$sql_name_order = ", v_name";
}
// VID Sortierung
if (isset ( $opt_sel ) && array_search ( 'vid_order', $opt_sel ) !== false) {
	$vid_order = true;
} else {
	$vid_order = false;
}
if (isset ( $opt_sel ) && array_search ( 'regio', $opt_sel ) !== false) {
	$regio = true;
	// Feld darf nicht "NULL" sein, da sonst das Template nicht mehr passt
	$sql_regio_field = ", IF(regiogericht_cn != gericht_cn, regiogericht_cn, '') AS gericht_regio";
	$sql_gericht_order = "IF(gericht_cn != regiogericht_cn, regiogericht_cn, gericht_cn)";
} else {
	$regio = false;
	$sql_regio_field = "";
	$sql_gericht_order = "gericht_cn";
}

// Query zusammenstellen
$sql = "SELECT gericht_cn $sql_regio_field, v_name $sql_vmod_field, v_beruf, vid, count(*) AS num, verw.bemerk AS bemerk";
if ($vid_order) {
	$sql .= ", (SELECT count(DISTINCT v_name) FROM k_eroef_cn AS k2 WHERE k2.vid = k1.vid " . $sql_where . ") AS num_groups";
}
$sql .= " FROM k_eroef_cn AS k1";
$sql .= " LEFT JOIN verw ON k1.vid = verw.id
		WHERE 1 " . $sql_where . "
		GROUP BY gericht_cn, v_name, v_beruf, vid";
if ($vid_order) {
	$sql .= " ORDER BY $sql_gericht_order, num_groups DESC, vid $sql_name_order, v_beruf";
} else {
	$sql .= " ORDER BY $sql_gericht_order $sql_name_order, v_beruf, vid";
}
$res = $db->query ( $sql );
$smarty->assign ( 'num_verw', $res->num_rows );

$liste = array ();
while ( $assoc = $res->fetch_assoc () ) {
	// lege Farbfeld an
	$assoc ['farbe'] = null;
	$liste [] = $assoc;
}

// Farbzuweisung

// Farbendefinition
require_once ("farben.php");

// sammle alle VIDs, fr die Farben generiert werden mssen
$vids = array ();
foreach ( $liste as $i ) {
	// wenn die vid nicht NULL ist, bernimm sie in die Liste
	if (! empty ( $i ['vid'] )) {
		$vids [] = $i ['vid'];
	}
}
// wenn es vids gibt, weise Farben zu
if ($vids != array ()) {
	// sortiert und ohne Duplikate
	$vids = array_unique ( $vids );
	sort ( $vids );
	// Gehe die Liste nochmal durch und nutze eine Referenz auf die Eintrge, um die Farbe hinzufgen zu knnen
	foreach ( $liste as &$assoc ) {
		// wenn vid nicht NULL ist
		if (! empty ( $assoc ['vid'] )) {
			// wenn der Index der vid grer ist als verfgbare Farben, dann schwarz
			$vid_index = array_search ( $assoc ['vid'], $vids );
			if (($vid_index + 1) > count ( $farben )) {
				$assoc ['farbe'] = "#000000";
			} else { // Farbe verfgbar
				$assoc ['farbe'] = $farben [$vid_index];
			}
		}
	}
}

$smarty->assign ( 'options', $opt );
$smarty->assign ( 'options_sel', $opt_sel );
$smarty->assign ( 'del_words', $del_words );
if (isset ( $aff )) {
	$smarty->assign ( 'affected_rows', $aff );
}
$smarty->assign ( 'gericht', $gericht );
$smarty->assign ( 'regio_gericht', $regio_gericht );
$smarty->assign ( 'liste', $liste );
$smarty->display ( 'vids.tpl' );

/*
 * Was umsetzen?
 * - Wrter streichen
 * - nach letztem Namen sortieren
 * - Anfangsbuchstaben eliminieren
 * - Beruf anzeigen
 */
?>